#include <qthing>

#include "esp_log.h"
#include "driver/gpio.h"

#include "freertos/FreeRTOS.h"
#include "freertos/task.h"


#include "CyanLightControl.hpp"



CyanLight::Controller ctrl(0, 1);


void device_main() {

  // ground the pin beneath our channel 0 IO
  /* uint8_t GND = 23;

  gpio_config_t conf;

  conf.intr_type = GPIO_INTR_DISABLE;
  conf.mode = GPIO_MODE_OUTPUT;
  conf.pin_bit_mask = 1ULL << GND;
  conf.pull_up_en = GPIO_PULLUP_DISABLE;
  conf.pull_down_en = GPIO_PULLDOWN_DISABLE;

  gpio_config(&conf);
  gpio_set_level((gpio_num_t)GND, 0); */


  qthing::Config cfg;
  cfg.apply();


  qthing::enable_wifi();

  return;

  auto delay = 10 / portTICK_PERIOD_MS;
  float limit = 50.0f;

  while (true) {
    for (uint8_t i = 0; i < limit; i++) {
      float pwm = i / limit;
      ctrl.setPWM(0, pwm*pwm);
      vTaskDelay(delay);
    }

    for (uint8_t i = 0; i < limit; i++) {
      float pwm = i / limit;
      ctrl.setPWM(0, 1.0f - pwm*pwm);
      vTaskDelay(delay);
    }
  }
}
